routes/web.php
<?php

use App\Http\Controllers\Auth;
use App\Http\Controllers\Dashboard;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get("/login",[Auth::class,"index"])->name("login");
Route::get("/",function (){
    return redirect()->route("login");
});
Route::post("/login",[Auth::class,"login"])->name("login.post");
Route::get("/logout",[Auth::class,"logout"])->name("logout");


Route::get("/dashboard",[Dashboard::class,"index"])->middleware("gateway:0|1|2|3|4|5")->name("dashboard");

Route::resource('penduduk', 'PendudukController')->middleware("gateway:0");
Route::resource('kk', 'KkController')->middleware("gateway:0");
Route::resource('surat', 'SuratController')->middleware("gateway:0");

app/Http/Controllers/PendudukController.php
<?php

namespace App\Http\Controllers;


use App\Casts\LevelAccount;
use App\Models\Citizen;
use App\Models\User;
use Illuminate\Http\Request;

class PendudukController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\View\View
     */
    public function index(Request $request)
    {
        $keyword = $request->get('search');
        if (!empty($keyword)) {
            $penduduk = Citizen::where('kk', 'LIKE', "%$keyword%")
                ->orWhere('nik', 'LIKE', "%$keyword%")
                ->orWhere('name', 'LIKE', "%$keyword%")
                ->orWhere('jk', 'LIKE', "%$keyword%")
                ->orWhere('agama', 'LIKE', "%$keyword%")
                ->orWhere('pekerjaan', 'LIKE', "%$keyword%")
                ->orWhere('alamat', 'LIKE', "%$keyword%")
                ->orWhere('agama', 'LIKE', "%$keyword%")
                ->orWhere('type', 'LIKE', "%$keyword%")
                ->orWhere('tempar_lahir', 'LIKE', "%$keyword%")
                ->orWhere('desa', 'LIKE', "%$keyword%")
                ->orWhere('tgl_lahir', 'LIKE', "%$keyword%")
                ->orWhere('tgl_datang', 'LIKE', "%$keyword%")
                ->orWhere('rt', 'LIKE', "%$keyword%")
                ->orWhere('rw', 'LIKE', "%$keyword%")
                ->latest()->get();
        } else {
            $penduduk = Citizen::latest()->get();
        }

        $title = "Data Kependudukan";
        return view('penduduk.index', compact('penduduk',"title"));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\View\View
     */
    public function create()
    {
        $mode = "create";
        $title = "Tambah Data Penduduk";
        return view('penduduk.form',compact("mode","title"));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param \Illuminate\Http\Request $request
     *
     * @return \Illuminate\Http\RedirectResponse|\Illuminate\Routing\Redirector
     */
    public function store(Request $request)
    {
        
        $requestData = $request->all();
        $createUser = User::create([
            "name"=>$requestData["name"],
            "username"=>$requestData["nik"],
            "password"=>$requestData["nik"],
            "level"=>LevelAccount::WARGA,
            "status"=>1,
        ]);
        $requestData["user_id"] = $createUser->id;
        Citizen::create($requestData);

        return redirect('/penduduk')->with('msg', 'Penduduk added!');
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     *
     * @return \Illuminate\View\View
     */
    public function show($id)
    {
        $penduduk = Citizen::findOrFail($id);
        $mode = "show";
        $title = "Detail Data [$penduduk->name]";
        return view('penduduk.form', compact('penduduk',"mode","title"));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     *
     * @return \Illuminate\View\View
     */
    public function edit($id)
    {
        $penduduk = Citizen::findOrFail($id);
        $mode = "edit";
        $title = "Edit Data [$penduduk->name]";
        return view('penduduk.form', compact('penduduk',"mode","title"));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param \Illuminate\Http\Request $request
     * @param  int  $id
     *
     * @return \Illuminate\Http\RedirectResponse|\Illuminate\Routing\Redirector
     */
    public function update(Request $request, $id)
    {
        
        $requestData = $request->all();
        
        $penduduk = Citizen::findOrFail($id);
        $penduduk->update($requestData);

        return redirect('/penduduk')->with('msg', 'Penduduk updated!');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     *
     * @return \Illuminate\Http\RedirectResponse|\Illuminate\Routing\Redirector
     */
    public function destroy($id)
    {
        Citizen::destroy($id);

        return redirect('/penduduk')->with('msg', 'Penduduk deleted!');
    }
}

resources/views/penduduk/form.blade.php
@extends('adminlte::page')

@section('title', ((isset($title))?$title:""))

@section('content_header')

@stop

@section('content')
    <div
            class="row"
            style="padding: 20px"
    >
        <div class="col-12">
            <div class="card">
                <div class="card-header">
                    <div class="card-title">{{$title}}</div>
                </div>
                <div class="card-body">
                    <form action="{{($mode === 'show')?"":route($mode === 'create' ?"penduduk.store":"penduduk.update",$mode === "edit"?@$penduduk->id:[])}}" method="post">
                        @if($mode === "edit")
                            @method("PUT")
                        @endif
                        @csrf
                        <div class="row">
                            <div class="col-6">
                                <div class="form-group">
                                    <label>NIK</label>
                                    <input type="number" class="form-control" name="nik" value="{{@$penduduk->nik}}" required />
                                </div>
                                <div class="form-group">
                                    <label>Nama Lengkap</label>
                                    <input type="text" class="form-control" name="name" required value="{{@$penduduk->name}}" />
                                </div>
                                <div class="form-group">
                                    <label>Jenis Kelamin</label>
                                    <select name="jk" id="jk" class="form-control">
                                        @if(@$penduduk->jk === 1)
                                            <option value="1" selected>Laki - Laki</option>
                                            <option value="2">Perempuan</option>
                                        @endif
                                        @if(@$penduduk->jk === 2)
                                            <option value="1">Laki - Laki</option>
                                            <option value="2" selected>Perempuan</option>
                                        @endif

                                        @if(!isset($penduduk->jk))
                                            <option value="1">Laki - Laki</option>
                                            <option value="2" selected>Perempuan</option>
                                        @endif
                                    </select>
                                </div>
                                <div class="form-group">
                                    <label>Status Hubungan</label>
                                    <select name="status_hubungan" id="status_hubungan" class="form-control">
                                        @foreach(\App\Casts\StatusHubungan::select(@$penduduk->status_hubungan) as $key => $v)
                                            <option value="{{$v["id"]}}" {{($v["selected"])?"selected":""}}>{{$v["text"]}}</option>
                                        @endforeach
                                    </select>
                                </div>

                                <div class="form-group">
                                    <label>Agama</label>
                                    <select name="agama" id="agama" class="form-control">
                                        @foreach(\App\Casts\ListAgama::select(@$penduduk->agama) as $key => $v)
                                            <option value="{{$v["id"]}}" {{($v["selected"])?"selected":""}}>{{$v["text"]}}</option>
                                        @endforeach
                                    </select>
                                </div>

                                <div class="form-group">
                                    <label>Pekerjaan</label>
                                    <input type="text" class="form-control" name="pekerjaan" value="{{@$penduduk->pekerjaan}}" required />
                                </div>

                                <div class="form-group">
                                    <label>Jenis Hubungan</label>
                                    <select name="type" id="type" class="form-control">
                                        @foreach(\App\Casts\CitizenType::select(@$penduduk->type) as $key => $v)
                                            <option value="{{$v["id"]}}" {{($v["selected"])?"selected":""}}>{{$v["text"]}}</option>
                                        @endforeach
                                    </select>
                                </div>

                                <div class="form-group">
                                    <label>Alamat</label>
                                    <textarea name="alamat" id="alamat" cols="30" rows="10" class="form-control">{{@$penduduk->alamat}}</textarea>
                                </div>

                            </div>
                            <div class="col-6">


                                <div class="form-group">
                                    <label>Tempat Lahir</label>
                                    <input type="text" class="form-control" name="tempat_lahir" required value="{{@$penduduk->tempat_lahir}}" />
                                </div>

                                <div class="form-group">
                                    <label>Tanggal Lahir</label>
                                    <input type="text" class="form-control date" name="tgl_lahir" value="{{@$penduduk->tgl_lahir}}" required />
                                </div>
                                <div class="form-group">
                                    <label>RT</label>
                                    <input type="text" class="form-control" name="rt" required value="{{@$penduduk->rt}}" />
                                </div>

                                <div class="form-group">
                                    <label>RW</label>
                                    <input type="text" class="form-control" name="rw" required  value="{{@$penduduk->rw}}" />
                                </div>

                                <div class="form-group">
                                    <label>Desa</label>
                                    <input type="text" class="form-control" name="desa" required  value="{{@$penduduk->desa}}" />
                                </div>
                                <div class="form-group">
                                    <label>Tanggal Datang</label>
                                    <input type="text" class="form-control date" name="tgl_datang" required  value="{{@$penduduk->tgl_datang}}" />
                                </div>
                                <div class="form-group">
                                    <label>Kepala Keluarga / Terkait Pada KK</label>
                                    <select name="citizen_id" class="form-control" id="citizen_id">
                                        @foreach(\App\Models\Citizen::whereNotNull("kk")->get() as $k => $v)
                                            <option value="{{$v->id}}">{{$v->kk}} - {{$v->name}}</option>
                                        @endforeach
                                    </select>
                                </div>

                                @if($mode !== "show")
                                    <div class="form-group">
                                        <button class="btn btn-success" type="submit">
                                            Simpan Data
                                        </button>
                                    </div>
                                @endif
                            </div>
                        </div>




                    </form>
                </div>
            </div>
        </div>
    </div>
@stop

@section('css')

@stop

@section("js")
    @include("msg")
    <script>
        $(document).ready(function () {
            $("table").dataTable()
            $(".date").datepicker({
                format:'yyyy-mm-dd'
            })


            @if($mode === "show")
                $("form").find("input").attr("disabled",true)
                $("form").find("textarea").attr("disabled",true)
                $("form").find("select").attr("disabled",true)
            @endif
        })
    </script>
@stop

resources/views/penduduk/index.blade.php
@extends('adminlte::page')

@section('title', ((isset($title))?$title:""))

@section('content_header')

@stop

@section('content')
    <div
            class="row"
            style="padding: 20px"
    >
        <div class="col-12">
            <div class="card">
                <div class="card-header">
                    <div class="card-title">Data Penduduk</div>
                </div>
                <div class="card-body">
                    <a style="margin-bottom: 10px" href="{{route("penduduk.create")}}" class="btn btn-success">
                        Tambah
                    </a>

                    <table class="table table-striped">
                        <thead>
                            <tr>
                                <th>No</th>
                                <th>KK</th>
                                <th>NIK</th>
                                <th>Nama</th>
                                <th>Jenis Kelamin</th>
                                <th>Status Hubungan</th>
                                <th>RT/RW</th>
                                <th>Aksi</th>
                            </tr>
                        </thead>
                        <tbody>
                            @foreach($penduduk as $k => $v)
                                <tr>
                                    <td>{{($k+1)}}</td>
                                    <td>{{$v->citizen->kk ?? $v->kk}}</td>
                                    <td>{{$v->nik}}</td>
                                    <td>{{$v->name}}</td>
                                    <td>{{$v->jk === 1 ? 'Laki - Laki':'Perempuan'}}</td>
                                    <td>{{\App\Casts\StatusHubungan::lang($v->status_hubungan)}}</td>
                                    <td>{{$v->rt}}/{{$v->rw}}</td>
                                    <td>
                                        <a href="{{route("penduduk.show",$v->id)}}" class="btn btn-primary m-2">Lihat</a>
                                        <a href="{{route("penduduk.edit",$v->id)}}" class="btn btn-warning m-2">Edit</a>
                                    </td>
                                </tr>
                            @endforeach
                        </tbody>
                    </table>
                </div>
            </div>
        </div>
    </div>
@stop

@section('css')

@stop

@section("js")
    @include("msg")
    <script>
        $(document).ready(function () {
            $("table").dataTable()
        })
    </script>
@stop